//+------------------------------------------------------------------+
//|                                           SSMaxMacdFilter_v1.mq4 |
//|                                                        Gary Hill |
//|                                                     Feb. 1, 2009 |
//+------------------------------------------------------------------+

#property indicator_chart_window

extern int TimeFrame  = 0;
extern int FastEMA = 12;
extern int SlowEMA = 26;
extern int SignalSMA = 9;
extern int applied_price = 0;
extern int maxtrendlines = 100;  //maximum number of trendlines visible, starts over after reaching the max

int bluemarker1, bluemarker2;
int redmarker1, redmarker2;
double bluenew, blueold;
double rednew, redold;
double macd_blue, macd_red;
string trendline;
int trend, counter, counter2;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0, OBJ_VLINE);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
      bluemarker1 = 0; bluemarker2 = 0; 
      redmarker1 = 0; redmarker2 = 0;
      bluenew = 0; blueold = 0;
      rednew = 0; redold = 0;
      
      for (int i=1; i<=500; i++)
      {
         double macd3 = (iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,2,i)); 
         double macd33 = iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,2,i+1);
         double macd4 = iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,3,i);
         double macd44 = iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,3,i+1);
         
         if (bluemarker1 == 0)   // testing for first blue set
         {
            if (macd3 > 0 && macd33 == 0)  //ox    start of blueset1
            { 
               bluemarker1 = 1; 
               if (macd3 > bluenew) bluenew = macd3;
            }
            if (macd3 > 0 && macd33 > 0)    // xx  values within blueset1
            {
               if (macd3 >= macd33 && macd3 >= bluenew) bluenew = macd3;
               else if (macd33 > bluenew) bluenew = macd33;
            }    
            if (macd3 == 0 && macd33 > 0)       // xo   end of blueset1
            {
               if (macd33 > bluenew) bluenew = macd33;
            }
         }
   
         else if (bluemarker1 == 1)   // testing for second blue set
         {
            if (macd3 > 0 && macd33 == 0)  //ox    start of blueset2
            { 
               bluemarker2 = 1; 
               if (macd3 > blueold) blueold = macd3;
            }
            if (macd3 > 0 && macd33 > 0)    // xx  values within blueset2
            {
               if (macd3 >= macd33 && macd3 >= blueold) blueold = macd3;
               else if (macd33 > blueold) blueold = macd33;
            }    
            if (macd3 == 0 && macd33 > 0)       // xo   end of blueset2
            {
               if (macd33 > blueold) blueold = macd33;
            }
         }                                           
         
         if (redmarker1 == 0)   // testing for first red set
         {
            if (macd4 < 0 && macd44 == 0)  //ox    start of redset1
            { 
               redmarker1 = 1; 
               if (macd4 < rednew) rednew = macd4;
            }
            if (macd4 < 0 && macd44 < 0)    // xx  values within redset1
            {
               if (macd4 <= macd44 && macd4 <= rednew) rednew = macd4;
               else if (macd44 < rednew) rednew = macd44;           
            }    
            if (macd4 == 0 && macd44 < 0)       // xo   end of redset1
            {
               if (macd44 < rednew) rednew = macd44;
            }
         }
            
         else if (redmarker1 == 1)   // testing for second red set
         {
            if (macd4 < 0 && macd44 == 0)  //ox    start of redset2
            { 
               redmarker2 = 1; 
               if (macd4 < redold) redold = macd4;
            }
            if (macd4 < 0 && macd44 < 0)    // xx  values within redset2
            {
               if (macd4 <= macd44 && macd4 <= redold) redold = macd4;
               else if (macd44 < redold) redold = macd44;
            }    
            if (macd4 == 0 && macd44 < 0)       // xo   end of redset2
            {
               if (macd44 < redold) redold = macd44;
            }
         }
         
         if (bluemarker1 == 1 && bluemarker2 == 1 && redmarker1 == 1 && redmarker2 ==1) // = 2 sets each of the most recent blue and red bars have been analyzed
         {         
            double macdblue = iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,2,1); 
            double macdred = iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,3,1); 
      
            if (trend == 0 || trend == -1 && macdblue > 0 && bluenew > blueold)
            {
               trend = 1;
               counter = counter + 1;
               counter2 = counter - maxtrendlines;
               if(counter > maxtrendlines) ObjectDelete("trendline"+counter2); 
               datetime time = iTime(NULL,0,1);
               ObjectCreate("trendline"+counter, OBJ_VLINE,0,time,0);
               ObjectSet("trendline"+counter,OBJPROP_COLOR,Blue); 
            }
            else if (trend == 0 || trend == 1 && macdred < 0 && rednew < redold)   
            {
               trend = -1;
               counter = counter + 1;
               counter2 = counter - maxtrendlines;
               if(counter > maxtrendlines) ObjectDelete("trendline"+counter2);
               time = iTime(NULL,0,1);
               ObjectCreate("trendline"+counter, OBJ_VLINE,0,time,0);
               ObjectSet("trendline"+counter,OBJPROP_COLOR,Red);
            }
            break;
         }       
      }           
   return(0);
  }
//+------------------------------------------------------------------+