//+------------------------------------------------------------------+
//|                                               SSZZiFilter_v1.mq4 |
//|                                                        Gary Hill |
//|                                                     Feb. 1, 2009 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property  indicator_buffers 1

//---- stochastic input parameters
extern int CCIPeriod = 14;
extern int maxtrendlines = 100;

double High1, High2;
double Low1, Low2;
double s1,s2,s3,s4,s5,s6;

string trendline;
int trend, counter, counter2;

double  TrendBuffer[];
    
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator buffers mapping
   SetIndexBuffer(0,TrendBuffer);
   SetIndexLabel(0,"Trend");
   IndicatorDigits(0);
   IndicatorShortName("SSZZiTrend  ");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0, OBJ_VLINE);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
      int limit;
      int counted_bars=IndicatorCounted();
      //---- last counted bar will be recounted
      if(counted_bars>0) counted_bars--;
      limit=Bars-counted_bars;
        
      for(int k=1; k<limit; k++)
      {
         High1 = 0; High2 = 0; 
         Low1 = 0; Low2 = 0;
         s1 = 0; s2 = 0; s3 = 0; s4 = 0;
         
         for (int i=1; i<=500; i++)
         {
            double value1 = iCustom(NULL, 0, "Zee Zee i",CCIPeriod,0,i);
            double value2 = iCustom(NULL, 0, "Zee Zee i",CCIPeriod,0,i+1);
            double value3 = iCustom(NULL, 0, "Zee Zee i",CCIPeriod,0,i+2);
            
            if(s1 == 0 && s2 == 0 && s3 == 0 && s4 == 0)
            {
               if(value1 > value2 && value2 < value3) s1 = value2;
               if(value1 < value2 && value2 > value3) s1 = value2;
            }
            else if(s1 != 0 && s2 == 0 && s3 == 0 && s4 == 0)
            {
               if(value1 > value2 && value2 < value3) s2 = value2;
               if(value1 < value2 && value2 > value3) s2 = value2;
            }
            else if(s1 != 0 && s2 != 0 && s3 == 0 && s4 == 0)
            {
               if(value1 > value2 && value2 < value3) s3 = value2;
               if(value1 < value2 && value2 > value3) s3 = value2;
            }
            else if(s1 != 0 && s2 != 0 && s3 != 0 && s4 == 0)
            {
               if(value1 > value2 && value2 < value3) s4 = value2;
               if(value1 < value2 && value2 > value3) s4 = value2;
            }
            else if(s1 != 0 && s2 != 0 && s3 != 0 && s4 != 0) break;
         }
         
         if(s1 > s2)
         {
            High1 = s1;
            Low1 = s2;
            High2 = s3;
            Low2 = s4;
         }
         if(s1 < s2)
         {
            Low1 = s1;
            High1 = s2;
            Low2 = s3;
            High2 = s4;
         }
         
         double value4 = iCustom(NULL, 0, "Zee Zee i",CCIPeriod,0,1);
               
         if(s1 == High1)
         {
            if(value4 < Low1) trend = -1;                    // = Breakout low = short trade     
            if(value4 < Low1 && High1 < High2) trend = -1;   // = Trade continuation = short trade
         }
         if(s1 == Low1)
         { 
            if(value4 > High1) trend = 1;                    // = Breakout high = long trade   
            if(value4 > High1 && Low1 > Low2) trend = 1;     // = Trade continuation = long trade 
         }
            
         TrendBuffer[k] = trend;
         int PriorTrend = TrendBuffer[k+1];
            
         if(trend == 1 && PriorTrend < trend)
         {
            counter = counter + 1;
            counter2 = counter - maxtrendlines;
            if(counter > maxtrendlines) ObjectDelete("trendline"+counter2); 
            datetime time = iTime(NULL,0,1);
            ObjectCreate("trendline"+counter, OBJ_VLINE,0,time,0);
            ObjectSet("trendline"+counter,OBJPROP_COLOR,Blue);             
         }
         else if(trend == -1 && PriorTrend > trend)
         {
            counter = counter + 1;
            counter2 = counter - maxtrendlines;
            if(counter > maxtrendlines) ObjectDelete("trendline"+counter2);
            time = iTime(NULL,0,1);
            ObjectCreate("trendline"+counter, OBJ_VLINE,0,time,0);
            ObjectSet("trendline"+counter,OBJPROP_COLOR,Red);
         } 
   }              
   return(0);
}
//+------------------------------------------------------------------+