//+----------------------------------------------------------------------------------------------+
//|                                                                   Slingshot_2.13_test EA.mq4 |
//|                                                                                              |
//|                                                                 originally modified by Orest |
//|                                                                            olponom@yahoo.com |
//|       multiple trade filters/options and many other features added 02/2009 by several others |
//+----------------------------------------------------------------------------------------------+

#include <stdlib.mqh>      // -NK- 20-Feb-2009
#include <stderror.mqh>    // -NK- 20-Feb-2009

extern string    basic = "==== Basic Settings ====================";
extern double    TakeProfit=0;
extern double    Stoploss=0;
extern double    Lots=0.1;
extern bool      UseRecommendedSLSettings = true;     // if false, use manual entry for SL
extern bool      UseATRForStopLoss = false;           // Version 2.11
extern int       ATRStopLossPeriod = 14;              // Version 2.11
extern double    ATRStopLossMultiplier = 2.0;           // Version 2.11
extern bool      UseATRForTakeProfit = false;         // Version 2.11
extern int       ATRTakeProfitPeriod = 14;            // Version 2.11
extern double    ATRTakeProfitMultiplier = 0.8;      // Version 2.11
extern bool      PlaySoundWhenTradePlaced = false;    // -NK- 20-Feb-2009
extern string    PlaySoundFile = "alert1.wav";        // -NK- 20-Feb-2009 - File must be located in the sounds folder. 
extern bool      AlertWhenTradePlaced = false;        // -NK- 20-Feb-2009

extern string    manage = "==== Order Management ====================";
extern int       BreakEvenAtProfit = 0;
extern int       BreakEvenShift = 0;               // Move the breakeven point up or down around the order open price
extern int       TrailingStop = 0;
extern bool      OnlyTrailAfterProfit = false;   // Trailing Stop will only trails when order is profitable
extern bool      Move_SL_to_Prev_Hi_Lo = true;   


extern string    account="==== Account Settings ====================";
extern int       MinimumEquity=0;                // New orders will be disabled if equity drops below minimum
extern int       MinimumBalance=0;               // New orders will be disabled if balance drops below minimum

//extern string    activity = "==== EA Activity Settings ====================";       //Gary 2/25/2009
//extern int       ConcurrentOrdersMax=1;                                             //Gary 2/25/2009

extern string    id = "==== Identity Settings ====================";
extern int       ExpertID=999999;               // Magic number: for identifying an EA's orders
extern bool      TimeSpecific=true;            // If true, Time frames are considered in determining
                                                // whether an order belongs to the EA or not
extern string    ExpertName="SlingShot ";    // Expert name: for aesthetic purposes

extern string    Trading_Times = "==== Trading Time Settings ====================";
extern bool      TradeSunday = false;
extern int       GMT_OffSet = 2;      //IBFX = 0, Alpari = +1, ForexMeta = +2, etc...
extern int       TimeToTrade1 = 6;  
extern int       TimeToTrade2 = 19;
extern int       FridayClose = 17;  

extern string    maxmacd = "==== MACD Colored Parameters ====================";

extern int FastEMA       = 12;
extern int SlowEMA       = 26;
extern int SignalSMA     = 9;
extern int applied_price = 0;

extern string stoch = "==== Stochastic Parameters ================";

extern int KPeriod = 8;
extern int DPeriod = 3;
extern int Slowing = 3;

extern string zzi = "==== ZZi Parameters =======================";

extern int CCIPeriod = 14;

extern string    money = "==== Money Management ====================";
extern bool Money_Management = false;
extern double Risk = 0.01;
extern int Max_StopLoss = 100;

extern string trades = "==== Trade Management ===================";
extern string tradedefinitions = "MMF = MaxMacdFilter, SF = StochFilter, ZF = ZZiFilter";
extern string tradesremark1 = "---- One Filter Trades ----";
extern bool TradeUsingMMF = true;
extern bool TradeUsingSF  = true;
extern bool TradeUsingZF  = true;
extern string tradesremark2 = "---- Two Filter Trades ----";
extern bool TradeUsingMMFandSF = false;
extern bool TradeUsingMMFandZF = false;
extern bool TradeUsingSFandZF  = false; 
extern string tradesremark3 = "---- Three Filter Trades ----";
extern bool TradeUsingMMFandSFandZF = false;   

int retry_attempts          = 10;    // -NK- 20-Feb-2009
double sleep_time           = 4.0;   // -NK- 20-Feb-2009
double sleep_maximum        = 25.0;  // -NK- 20-Feb-2009 - in seconds
static int _OR_err          = 0;     // -NK- 20-Feb-2009
string OrderReliable_Fname  = "None"; // -NK- 20-Feb-2009
string OrderReliableVersion = "V0_2_3"; // -NK- 20-Feb-2009

bool      DisableClosingOrders=false;    // If true, the order closing section of the EA will not run
bool      DisableNewOrders=false;        // If true, the order creating section of the EA will not run

int ConcurrentOrdersMax = 1;   //temporary variable while the extern is commented out 2/25/2009  Gary

bool belowLowPreviousBar    = false;
bool aboveClosePreviousBar  = false;

bool aboveHighPreviousBar   = false;
bool belowClosePreviousBar  = false;
datetime barTime = 0; 
int mmacdtrend = 0, strend = 0, ztrend = 0;
string pos1 = "_", pos2 = "_", pos3 = "_", pos4 = "_", pos5 = "_", pos6 = "_", pos7 = "_";

bool BuySignal, SellSignal;

double dblPoints;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   dblPoints = GetPoints();
   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{    
      string comment = "";
      int total = 0;
      
      int buyOrders=0, sellOrders=0, buyPending=0, sellPending=0;
      checkOrderStatus(buyOrders, sellOrders, buyPending, sellPending);
      int instantOrders = buyOrders + sellOrders;
      int pendingOrders = buyPending + sellPending;
      int allOrders     = instantOrders + pendingOrders;
      advancedStopManager(instantOrders);
      
      double lotSize = MarketInfo(Symbol(), MODE_LOTSIZE);
      
      int StopLossType = 0; // 0=Manual; 1=Default Settings; 2=ATR Calculation
      int TakeProfitType = 0; // 0=Manual; 2=ATR Calculation
            
      if(UseRecommendedSLSettings == true)
      {
         Stoploss = 40; // -NK- 20-Feb-2009. This is a catchall in case the EA is placed on other currencies not listed here. 
         if(Symbol()=="EURUSD") Stoploss = 35;
         if(Symbol()=="EURJPY") Stoploss = 45;
         if(Symbol()=="GBPJPY") Stoploss = 55;
         if(Symbol()=="GBPUSD") Stoploss = 45;
         if(Symbol()=="USDJPY") Stoploss = 25;
         StopLossType = 1;
      }  
      
      //+------------------------------------------------------------------+
      //| Calculate ATR for both StopLoss and TakeProfit if selected       |
      //| Version 2.11                                                     |
      //+------------------------------------------------------------------+

      if (UseATRForStopLoss == true)
      {
         double atrsl = iATR(NULL, NULL, ATRStopLossPeriod, 1);
         Stoploss = atrsl / dblPoints  * ATRStopLossMultiplier;
         StopLossType = 2;
      }
      
      if (UseATRForTakeProfit == true)
      {
         double atrtp = iATR(NULL, NULL, ATRTakeProfitPeriod, 1); 
         TakeProfit = atrtp / dblPoints * ATRTakeProfitMultiplier;
         TakeProfitType = 2;
      }
      
    
      if (!IsTimeToTrade()) 
         Comment("Outside trading window","\n",
                 "StopLoss = ",Stoploss);
      
      if (IsTimeToTrade() && allOrders == 0) 
         Comment("Inside trading window, no open orders","\n",
                 "StopLoss = ",Stoploss);
      
      //+------------------------------------------------------------------+
      //| Modified Comment to provide information on  SL and TP values     |
      //| Version 2.11                                                     |
      //+------------------------------------------------------------------+
      if (IsTimeToTrade())
      {
          string str = "Inside trading window," + " " + instantOrders + " order(s)" + "\n" + "Trading Options Used: "; 
          str = str + " " + pos1 + " " +  pos2+  " " + pos3 + " " + pos4 + " " + pos5 + " " + pos6 + " " + pos7 + "\n" + "StopLoss = " + DoubleToStr(Stoploss, 0) + " (";
          if (StopLossType == 0) str = str + "Manual)";
          if (StopLossType == 1) str = str + "Pre-Defined StopLoss)";
          if (StopLossType == 2) str = str + "Calculated ATR = " + DoubleToStr(atrsl / dblPoints, 1) + " with Multiplier = " + DoubleToStr(ATRStopLossMultiplier,1) + ")" ;
          str = str + "\n" + "Take Profit = " + DoubleToStr(TakeProfit,0) + " (";
          
          if (TakeProfitType == 0) str = str + "Manual)";   
          if (TakeProfitType == 2) str = str + "Calculated ATR " + DoubleToStr(atrtp / dblPoints, 1) + " with Multiplier = " + DoubleToStr(ATRTakeProfitMultiplier, 1) + ")";        
          Comment(str);
      }
      
 //+------------------------------------------------------------------+
 //|  filter trends                                                   |
 //+------------------------------------------------------------------+
 
      mmacdtrend = MaxMacdTrend();
      strend = StochTrend();
      ztrend = ZZiTrend();       

//+------------------------------------------------------------------+
//| variable and indicator declaration                               |
//+------------------------------------------------------------------+
      
      if(barTime < Time[0])
      {
         // we have a new bar opened
         barTime = Time[0]; // keep the new bar open time     
         belowLowPreviousBar    = false;
         aboveClosePreviousBar  = false;

         aboveHighPreviousBar   = false;
         belowClosePreviousBar  = false;

         if (OrdersTotal() > 0 && Move_SL_to_Prev_Hi_Lo == true) moveStopLosses();
      }

//+------------------------------------------------------------------+
//| close existing orders under appropriate conditions               |
//+------------------------------------------------------------------+

      if (DisableClosingOrders==false && allOrders > 0) CheckClosingConditions();
  
 //+------------------------------------------------------------------+
 //|  Checking for Opening new trades                                 |
 //+------------------------------------------------------------------+
      
      if (pos1=="_" || pos2=="_" || pos3=="_" || pos4=="_" || pos5=="_" || pos6=="_" || pos7=="_" && IsTimeToTrade()) CheckForTrades();
                      
  return(0);
}
  
//+------------------------------------------------------------------+
//| middle-man modules                                               |
//+------------------------------------------------------------------+

void sendBuyOrder() // Standard Version 1.71
{ versatileOrderTaker(1, Ask); }
   
//+------------------------------------------------------------------+

void sendSellOrder() // Standard Version 1.71
{ versatileOrderTaker(2, Bid); }

//+------------------------------------------------------------------+

void sendBuyPending(double entryPrice) // Standard Version 1.71
{ versatileOrderTaker(3, entryPrice); }

//+------------------------------------------------------------------+

void sendSellPending(double entryPrice) // Standard Version 1.71
{ versatileOrderTaker(4, entryPrice); }

//+------------------------------------------------------------------+

void closeSellOrder() // Standard Version 1.71
{ versatileOrderCloser(2); }

//+------------------------------------------------------------------+

void closeBuyOrder() // Standard Version 1.71
{ versatileOrderCloser(1); }

//+------------------------------------------------------------------+

void deletePending() // Standard Version 1.71
{ versatileOrderCloser(3); }

//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| modules and functions                                            |
//+------------------------------------------------------------------+

void trailingStopManager() // Standard Version 1.71
{
   
   int cnt, total = OrdersTotal();

   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if (TrailingStop>0 && orderBelongsToMe())
      {
         if (OrderType()==OP_BUY)
         {
            if ((Bid-OrderOpenPrice()>dblPoints*TrailingStop) || OnlyTrailAfterProfit==false)
            {
               if (OrderStopLoss()<Bid-dblPoints*TrailingStop)
                  OrderModifyReliable(OrderTicket(),OrderOpenPrice(),Bid-dblPoints*TrailingStop,OrderTakeProfit(),0,Green); 
            }
         }
         else if (OrderType()==OP_SELL)
         {
            if ((OrderOpenPrice()-Ask>dblPoints*TrailingStop) || OnlyTrailAfterProfit==false)
            {
               if ((OrderStopLoss()>(Ask+dblPoints*TrailingStop)) || (OrderStopLoss()==0))
                  OrderModifyReliable(OrderTicket(),OrderOpenPrice(),Ask+dblPoints*TrailingStop,OrderTakeProfit(),0,Red); 
            }
         }
      }  
   }
}

//+------------------------------------------------------------------+

void moveStopLosses() 
{
   int cnt, total = OrdersTotal();
    double dblStop;

   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      int index = iBarShift(NULL, 0 , OrderOpenTime()); 
      if (index==-1) return; 
     
      if (orderBelongsToMe() && OrderProfit() < 0)
      {
         if (OrderType() == OP_BUY)
         {
          dblStop = Low[index]-1*dblPoints;
          if (dblStop != OrderStopLoss()) OrderModifyReliable(OrderTicket(),OrderOpenPrice(),dblStop,OrderTakeProfit(),0,Green); 
         }
         else if (OrderType() == OP_SELL)
         {
         dblStop = High[index] + (MarketInfo(Symbol(),MODE_SPREAD)*dblPoints)+ 1*dblPoints; 
         if (dblStop != OrderStopLoss()) OrderModifyReliable(OrderTicket(),OrderOpenPrice(),dblStop,OrderTakeProfit(),0,Red); 
         }
      }  
   }
}

//+------------------------------------------------------------------+

void breakEvenManager() // Standard Version 1.71
{

   for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if (BreakEvenAtProfit>0 && orderBelongsToMe())
      {
         if (OrderType()==OP_BUY)
         {
            if (Bid-OrderOpenPrice()>=dblPoints*BreakEvenAtProfit)
            {
               if (OrderStopLoss()!=OrderOpenPrice() + BreakEvenShift*dblPoints)
                  OrderModifyReliable(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+ BreakEvenShift*dblPoints,OrderTakeProfit(),0,LimeGreen); 
            }
         }
         else if (OrderType()==OP_SELL)
         {
            if (OrderOpenPrice()-Ask>=dblPoints*BreakEvenAtProfit)
            {
               if (OrderStopLoss()!=OrderOpenPrice() - BreakEvenShift*dblPoints)
                  OrderModifyReliable(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()- BreakEvenShift*dblPoints,OrderTakeProfit(),0,Tomato); 
            }
         }
      }
   }
}
   
//+------------------------------------------------------------------+

 // Standard Version 1.71
void checkOrderStatus(int& buyOrders,int& sellOrders,int& buyPending, int& sellPending)
{
   for(int cnt=OrdersTotal();cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if ( orderBelongsToMe() )
      {  
         if (OrderType()==OP_BUY)
            {buyOrders++;}
         else if (OrderType()==OP_SELL)
            {sellOrders++;}
         else if (OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT)
            {buyPending++;}
         else if (OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT)
            {sellPending++;}
      }
   }
}

//+------------------------------------------------------------------+

void advancedStopManager(int instantOrders) // Standard Version 1.71
{
    
   if (instantOrders>=1)
   {
      if (BreakEvenAtProfit>0)
         breakEvenManager();
      if (TrailingStop>0)
         trailingStopManager();
    }
}

//+------------------------------------------------------------------+

bool orderBelongsToMe() // Standard Version 1.71
{
   if (OrderSymbol()==Symbol() && OrderMagicNumber()==simpleMagicGenerator() )
       return (true);
   else
      return (false);
}

//+------------------------------------------------------------------+

int simpleMagicGenerator() // Standard Version 1.71
{

   int truMagic;
   
   if (TimeSpecific)
      truMagic = ExpertID + (Period()*17 + 203);
   else
      truMagic = ExpertID;      

   return (truMagic);

}

//+------------------------------------------------------------------+

string commentString() // Standard Version 1.71
{
   string tfString, fullComment;
   
   switch (Period())  
   {   
      case 1:      tfString = "1 Min";    break;
      case 5:      tfString = "5 Min";    break;
      case 15:     tfString = "15 Min";   break;  
      case 30:     tfString = "30 Min";   break;  
      case 60:     tfString = "1 Hour";   break;  
      case 240:    tfString = "4 Hour";   break;  
      case 1440:   tfString = "Daily";    break;  
      case 10080:  tfString = "Weekly";   break;  
      case 40320:  tfString = "Monthly";  break;  
      default:     tfString = "Unknown";   
   }

   fullComment=StringConcatenate(ExpertName, ": ", tfString);
   return (fullComment);
}

//+------------------------------------------------------------------+

double lotMaker() // Standard Version 1.71 Simplified
{
   if (! Money_Management)
         return (Lots);        

	double pipValue = MarketInfo(Symbol(), MODE_TICKVALUE);
	double lots = AccountFreeMargin() * Risk / (Max_StopLoss * pipValue);
	
	double lotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
	int digits = 0;
	if(lotStep <= 0.01)
		digits = 2;
	else if(lotStep <= 0.1)
		digits = 1;
	lots = NormalizeDouble(lots, digits);
  	
  	double minLots = MarketInfo(Symbol(), MODE_MINLOT);
  	if(lots < minLots)
  		lots = minLots;
  	
  	double maxLots = MarketInfo(Symbol(), MODE_MAXLOT);
  	if(lots > maxLots)
  		lots = maxLots;
  	
  	return (lots);
}

//+------------------------------------------------------------------+

bool newOrderPrevention(int allOrders) // Standard Version 1.71
{

   if (DisableNewOrders)
      { Comment("New Orders Disabled:  User option"); return (true); }
   else if (AccountEquity()<MinimumEquity)
      { Comment("New Orders Disabled:  Equity too low"); return (true);}
   else if (AccountBalance()<MinimumBalance)
      { Comment("New Orders Disabled:  Balance too low"); return (true);}
   else if (allOrders>=ConcurrentOrdersMax)
      { Comment("New Orders Disabled:  Too many existing orders"); return (true);}
   else
      return (false);
}

//+------------------------------------------------------------------+

void versatileOrderTaker(int simpleType, double entryPrice) // Standard Version 1.71
{

   // Variable calculations

   double Stopvalue=0, TPvalue=0;
   int ticket, oType, slippage=3;
   string typeName;
   color c_color;
   
   c_color = Green;

   switch (simpleType)
   {
      case 4: 
      if (entryPrice<Bid)  { oType=OP_SELLSTOP;  typeName="SELLSTOP"; }
      if (entryPrice>Bid)  { oType=OP_SELLLIMIT; typeName="SELLLIMIT"; }
      if (Stoploss>0)      {Stopvalue = entryPrice+Stoploss*dblPoints;}
      if (TakeProfit>0)    {TPvalue = entryPrice-TakeProfit*dblPoints;}
      break;
         
      case 3:
      if (entryPrice>Ask)  { oType=OP_BUYSTOP;  typeName="BUYSTOP"; }
      if (entryPrice<Ask)  { oType=OP_BUYLIMIT; typeName="BUYLIMIT"; }
      if (Stoploss>0)      {Stopvalue = entryPrice-Stoploss*dblPoints;}
      if (TakeProfit>0)    {TPvalue = entryPrice+TakeProfit*dblPoints;}
      break;

      case 2:
      oType=OP_SELL; typeName="SELL"; 
      c_color = Red;
      if (Stoploss>0)      {Stopvalue = entryPrice+Stoploss*dblPoints;}
      if (TakeProfit>0)    {TPvalue = entryPrice-TakeProfit*dblPoints;}
      break;

      case 1:
      oType=OP_BUY; typeName="BUY"; 
      if (Stoploss>0)      {Stopvalue = entryPrice-Stoploss*dblPoints;}
      if (TakeProfit>0)    {TPvalue = entryPrice+TakeProfit*dblPoints;}
      break;
      
      default:
      Print ("versatileOrderTaker has been passed an invalid SimpleType parameter: " + simpleType);
   }

   // Send Order
   
   string filtercomment =commentString() + "  " + (pos1+pos2+pos3+pos4+pos5+pos6+pos7 );
   OrderSendReliable(Symbol(), oType, lotMaker(),entryPrice,slippage,Stopvalue,TPvalue,filtercomment,simpleMagicGenerator(),0,c_color);   // Version 2.11 as suggested by Gary. 
}

//+------------------------------------------------------------------+

void versatileOrderCloser(int simpleType) // Standard Version 1.71
{
   int cnt, result, total = OrdersTotal();

   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      
      if ( orderBelongsToMe() )
      {
         switch (simpleType)
         {
            case 4:
            case 3:
               //if (OrderType()>OP_SELL)   OrderDelete(OrderTicket());        //this is an error that needs fixing
            break;
         
            case 2:
                     if (OrderType()==OP_SELL)  
                     {
                        result = OrderCloseReliable(OrderTicket(),OrderLots(),Ask,3,CLR_NONE); 
                        if (result == true && PlaySoundWhenTradePlaced == true) {PlaySound(PlaySoundFile);}
                        if (result == true && AlertWhenTradePlaced == true) {Alert(ExpertName + " placed an order on " + Symbol());}
                     }
// -NK- 20-Feb-09              if (OrderType()==OP_SELL)  OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE); 
            break;
         
            case 1:
// -NK- 20-Feb-09              if (OrderType()==OP_BUY)   OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE); 
                     if (OrderType()==OP_BUY)  
                     {
                        result = OrderCloseReliable(OrderTicket(),OrderLots(),Bid,3,CLR_NONE); 
                        if (result == true && PlaySoundWhenTradePlaced == true) {PlaySound(PlaySoundFile);}
                        if (result == true && AlertWhenTradePlaced == true) {Alert(ExpertName + " placed an order on " + Symbol());}
                     }
            break;
         
            default:
            Print ("versatileOrderCloser has been passed an invalid SimpleType parameter: " + simpleType);
         }
      }
   }
}

//+------------------------------------------------------------------+

void OrderCloseAll()
{
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();

    bool result = false;
    
    switch(type)
    {
      //Close opened long positions
      case OP_BUY       : result = OrderCloseReliable( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 3, Gold );
                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderCloseReliable( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 3, Gold );
                          break;

      //Close pending orders
      case OP_BUYLIMIT  :
      case OP_BUYSTOP   :
      case OP_SELLLIMIT :
      case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
    }
    
    if(result == false)
    {
      Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
      Sleep(3000);
    }  
  }
  
  return(0);
}

//+------------------------------------------------------------------+

bool NewBar()
{    
   static datetime lastbar = 0;   
   datetime curbar = Time[0];    
   if(lastbar!=curbar)   
   {      
      lastbar=curbar;      
      return(true);   
   }   
   else   
   { 
      return(false);
   }
} 


//+------------------------------------------------------------------+

double GetPoints()           //changes point for 3,4 or 5 point brokers
{
   if(Digits == 3 || Digits == 5) dblPoints = Point*10;
   else dblPoints = Point;
   
   return(dblPoints);
}

//+------------------------------------------------------------------+

bool IsTimeToTrade()
{
   bool res = false;
   if(TradeSunday == false && Hour() >= TimeToTrade1+GMT_OffSet && Hour() <= TimeToTrade2+GMT_OffSet && DayOfWeek()!=0 && DayOfWeek()!=5) res = true;
   else if(TradeSunday == true && Hour() >= TimeToTrade1+GMT_OffSet && Hour() <= TimeToTrade2+GMT_OffSet && DayOfWeek()!=5) res = true;
   else if(DayOfWeek()==5 && Hour() >= TimeToTrade1+GMT_OffSet && Hour() <= FridayClose+GMT_OffSet) res = true;
   return(res);
}

//+------------------------------------------------------------------+

bool CheckForTrades()
{
   if(NewBar() && IsTimeToTrade())
      {
         BuySignal = false;
         SellSignal = false;
         pos1 = "_"; pos2 = "_"; pos3 = "_"; pos4 = "_"; pos5 = "_"; pos6 = "_"; pos7 = "_";
      }
          
      if(Low[0] < Low[1] &&  Bid >= NormalizeDouble(Close[1]+(MarketInfo(Symbol(),MODE_SPREAD)*dblPoints)+ 1*dblPoints, Digits)) BuySignal = true;  
      if(High[0] > High[1] && Bid <= NormalizeDouble(Close[1]-1*dblPoints, Digits)) SellSignal = true;
     
      if(BuySignal == true && TradeUsingMMF == true && mmacdtrend == 1) bool TradeOptionBuy1 = true;
      if(BuySignal == true && TradeUsingSF == true && strend == 2) bool TradeOptionBuy2 = true;
      if(BuySignal == true && TradeUsingZF == true && ztrend == 3) bool TradeOptionBuy3 = true;
      if(BuySignal == true && TradeUsingMMFandSF == true && mmacdtrend == 1 && strend == 2) bool TradeOptionBuy4 = true;
      if(BuySignal == true && TradeUsingMMFandZF == true && mmacdtrend == 1 && ztrend == 3) bool TradeOptionBuy5 = true;
      if(BuySignal == true && TradeUsingSFandZF == true && strend == 2 && ztrend == 3) bool TradeOptionBuy6 = true;
      if(BuySignal == true && TradeUsingMMFandSFandZF == true && mmacdtrend == 1 && strend == 2 && ztrend == 3) bool TradeOptionBuy7 = true;
        
      if(SellSignal == true && TradeUsingMMF == true && mmacdtrend == -1) bool TradeOptionSell1 = true;
      if(SellSignal == true && TradeUsingSF == true && strend == -2) bool TradeOptionSell2 = true;
      if(SellSignal == true && TradeUsingZF == true && ztrend == -3) bool TradeOptionSell3 = true;
      if(SellSignal == true && TradeUsingMMFandSF == true && mmacdtrend == -1 && strend == -2) bool TradeOptionSell4 = true;
      if(SellSignal == true && TradeUsingMMFandZF == true && mmacdtrend == -1 && ztrend == -3) bool TradeOptionSell5 = true;
      if(SellSignal == true && TradeUsingSFandZF == true && strend == -2 && ztrend == -3) bool TradeOptionSell6 = true;
      if(SellSignal == true && TradeUsingMMFandSFandZF == true && mmacdtrend == -1 && strend == -2 && ztrend == -3) bool TradeOptionSell7 = true;
       
      if(TradeOptionBuy1 == true && pos1 == "_"){
         pos1 = "1";
         sendBuyOrder(); } 
      if(TradeOptionBuy2 == true && pos2 == "_"){
         pos2 = "2"; 
         sendBuyOrder(); }
      if(TradeOptionBuy3 == true && pos3 == "_"){
         pos3 = "3"; 
         sendBuyOrder(); } 
      if(TradeOptionBuy4 == true && pos4 == "_"){
         pos4 = "4";
         sendBuyOrder(); }
      if(TradeOptionBuy5 == true && pos5 == "_"){
         pos5 = "5";
         sendBuyOrder(); }
      if(TradeOptionBuy6 == true && pos6 == "_"){
         pos6 = "6"; 
         sendBuyOrder(); }      
      if(TradeOptionBuy7 == true && pos7 == "_"){
         pos7 = "7"; 
         sendBuyOrder(); }
             
      if(TradeOptionSell1 == true && pos1 == "_"){
         pos1 = "1"; 
         sendSellOrder(); }
      if(TradeOptionSell2 == true && pos2 == "_"){
         pos2 = "2"; 
         sendSellOrder(); }   
      if(TradeOptionSell3 == true && pos3 == "_"){
         pos3 = "3"; 
         sendSellOrder(); }
      if(TradeOptionSell4 == true && pos4 == "_"){
         pos4 = "4"; 
         sendSellOrder(); }
      if(TradeOptionSell5 == true && pos5 == "_"){
         pos5 = "5"; 
         sendSellOrder(); }  
      if(TradeOptionSell6 == true && pos6 == "_"){
         pos6 = "6"; 
         sendSellOrder(); }
      if(TradeOptionSell7 == true && pos7 == "_"){
         pos7 = "7"; 
         sendSellOrder(); }                      
}
//+------------------------------------------------------------------+

void CheckClosingConditions()
{
if (NewBar())
      {
         int cnt;
         int total = OrdersTotal();

         for(cnt=0;cnt<total;cnt++)
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        
            if (orderBelongsToMe() && OrderOpenTime()< Time[1] && OrderProfit() >= 0)
            {
               if (OrderType()==OP_BUY)
               {
                  if (OrderProfit() > 0)           
                  {
                     closeBuyOrder();
                     //OrderCloseAll();
                  }
               }
               else if (OrderType()==OP_SELL)
               {
                  if (OrderProfit() > 0)         
                  {
                     closeSellOrder();
                     //OrderCloseAll();
                  }
               }
            }
              
            if (orderBelongsToMe() && OrderOpenTime()< Time[0] && OrderOpenTime() >= Time[1] && OrderProfit() > 1)
            {
               if (OrderType()==OP_BUY)
               {
                  if (OrderProfit() > 0)           
                  {
                     closeBuyOrder();
                     //OrderCloseAll();
                  }
               }
               else if (OrderType()==OP_SELL)
               {
                  if (OrderProfit() > 0)         
                  {
                     closeSellOrder();
                     //OrderCloseAll();
                  }
               }
            }           
         }
      }
}

//+------------------------------------------------------------------+

int StochTrend()
{
   double s1 = 0.0, s2 = 0.0 ,s3 = 0.0, s4 = 0.0;
   double High1 = 0.0, High2 = 0.0, Low1 = 0.0, Low2 = 0.0;
   
   for (int j=1; j<=500; j++)
         {        
            double value1 = iCustom(NULL, 0, "Stochastic",KPeriod,DPeriod,Slowing,0,j);
            double value2 = iCustom(NULL, 0, "Stochastic",KPeriod,DPeriod,Slowing,0,j+1);
            double value3 = iCustom(NULL, 0, "Stochastic",KPeriod,DPeriod,Slowing,0,j+2);
            
            if(s1 == 0 && s2 == 0 && s3 == 0 && s4 == 0)
            {
               if(value1 > value2 && value2 < value3) s1 = value2;
               if(value1 < value2 && value2 > value3) s1 = value2;
            }
            else if(s1 != 0 && s2 == 0 && s3 == 0 && s4 == 0)
            {
               if(value1 > value2 && value2 < value3) s2 = value2;
               if(value1 < value2 && value2 > value3) s2 = value2;
            }
            else if(s1 != 0 && s2 != 0 && s3 == 0 && s4 == 0)
            {
               if(value1 > value2 && value2 < value3) s3 = value2;
               if(value1 < value2 && value2 > value3) s3 = value2;
            }
            else if(s1 != 0 && s2 != 0 && s3 != 0 && s4 == 0)
            {
               if(value1 > value2 && value2 < value3) s4 = value2;
               if(value1 < value2 && value2 > value3) s4 = value2;
            }
            else if(s1 != 0 && s2 != 0 && s3 != 0 && s4 != 0) break;
         }
     
         if(s1 > s2)
         {
            High1 = s1;
            Low1 = s2;
            High2 = s3;
            Low2 = s4;
         }
         if(s1 < s2)
         {
            Low1 = s1;
            High1 = s2;
            Low2 = s3;
            High2 = s4;
         }
         
         double value4 = iCustom(NULL, 0, "Stochastic",KPeriod,DPeriod,Slowing,0,1);
              
         if(s1 == High1)
         {
            if(value4 < Low1) strend = -2;                    // = Breakout low = short trade     
            if(value4 < Low1 && High1 < High2) strend = -2;   // = Trade continuation = short trade       
         }
         
         if(s1 == Low1)
         { 
            if(value4 > High1) strend = 2;                    // = Breakout high = long trade   
            if(value4 > High1 && Low1 > Low2) strend = 2;     // = Trade continuation = long trade        
         }
   return(strend); 
}
//+------------------------------------------------------------------+

int ZZiTrend()
{
   double ss1 = 0.0 ,ss2 = 0.0, ss3 = 0.0, ss4 = 0.0;
   double HHigh1 = 0.0, HHigh2 = 0.0, LLow1 = 0.0, LLow2 = 0.0;
   
   for (int ii=1; ii<=500; ii++)
         {
            double vvalue1 = iCustom(NULL, 0, "Zee Zee i",CCIPeriod,0,ii);
            double vvalue2 = iCustom(NULL, 0, "Zee Zee i",CCIPeriod,0,ii+1);
            double vvalue3 = iCustom(NULL, 0, "Zee Zee i",CCIPeriod,0,ii+2);
            
            if(ss1 == 0 && ss2 == 0 && ss3 == 0 && ss4 == 0)
            {
               if(vvalue1 > vvalue2 && vvalue2 < vvalue3) ss1 = vvalue2;
               if(vvalue1 < vvalue2 && vvalue2 > vvalue3) ss1 = vvalue2;
            }
            else if(ss1 != 0 && ss2 == 0 && ss3 == 0 && ss4 == 0)
            {
               if(vvalue1 > vvalue2 && vvalue2 < vvalue3) ss2 = vvalue2;
               if(vvalue1 < vvalue2 && vvalue2 > vvalue3) ss2 = vvalue2;
            }
            else if(ss1 != 0 && ss2 != 0 && ss3 == 0 && ss4 == 0)
            {
               if(vvalue1 > vvalue2 && vvalue2 < vvalue3) ss3 = vvalue2;
               if(vvalue1 < vvalue2 && vvalue2 > vvalue3) ss3 = vvalue2;
            }
            else if(ss1 != 0 && ss2 != 0 && ss3 != 0 && ss4 == 0)
            {
               if(vvalue1 > vvalue2 && vvalue2 < vvalue3) ss4 = vvalue2;
               if(vvalue1 < vvalue2 && vvalue2 > vvalue3) ss4 = vvalue2;
            }
            else if(ss1 != 0 && ss2 != 0 && ss3 != 0 && ss4 != 0) break;
         }
         
         if(ss1 > ss2)
         {
            HHigh1 = ss1;
            LLow1 = ss2;
            HHigh2 = ss3;
            LLow2 = ss4;
         }
         if(ss1 < ss2)
         {
            LLow1 = ss1;
            HHigh1 = ss2;
            LLow2 = ss3;
            HHigh2 = ss4;
         }
         
         double vvalue4 = iCustom(NULL, 0, "Zee Zee i",CCIPeriod,0,1);
               
         if(ss1 == HHigh1)
         {
            if(vvalue4 < LLow1) ztrend = -3;                    // = Breakout low = short trade     
            if(vvalue4 < LLow1 && HHigh1 < HHigh2) ztrend = -3;   // = Trade continuation = short trade
         }
         if(ss1 == LLow1)
         { 
            if(vvalue4 > HHigh1) ztrend = 3;                    // = Breakout high = long trade   
            if(vvalue4 > HHigh1 && LLow1 > LLow2) ztrend = 3;     // = Trade continuation = long trade 
         }
   return(ztrend);
}
//+------------------------------------------------------------------+    

int MaxMacdTrend()
{
      int TimeFrame = 0;

      int bluemarker1 = 0, bluemarker2 = 0; 
      int redmarker1 = 0, redmarker2 = 0;
      double bluenew = 0.0, blueold = 0.0;
      double rednew = 0.0, redold = 0.0;
      
      for (int i=1; i<=500; i++)
      {
         double macd3 =  iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,2,i); 
         double macd33 = iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,2,i+1);
         double macd4 =  iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,3,i);
         double macd44 = iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,3,i+1);
         
         if (bluemarker1 == 0)   // testing for first blue set
         {
            if (macd3 > 0 && macd33 == 0)  //ox    start of blueset1
            { 
               bluemarker1 = 1; 
               if (macd3 > bluenew) bluenew = macd3;
            }
            if (macd3 > 0 && macd33 > 0)    // xx  values within blueset1
            {
               if (macd3 >= macd33 && macd3 >= bluenew) bluenew = macd3;
               else if (macd33 > bluenew) bluenew = macd33;
            }    
            if (macd3 == 0 && macd33 > 0)       // xo   end of blueset1
            {
               if (macd33 > bluenew) bluenew = macd33;
            }
         }
   
         else if (bluemarker1 == 1)   // testing for second blue set
         {
            if (macd3 > 0 && macd33 == 0)  //ox    start of blueset2
            { 
               bluemarker2 = 1; 
               if (macd3 > blueold) blueold = macd3;
            }
            if (macd3 > 0 && macd33 > 0)    // xx  values within blueset2
            {
               if (macd3 >= macd33 && macd3 >= blueold) blueold = macd3;
               else if (macd33 > blueold) blueold = macd33;
            }    
            if (macd3 == 0 && macd33 > 0)       // xo   end of blueset2
            {
               if (macd33 > blueold) blueold = macd33;
            }
         }                                           
         
         if (redmarker1 == 0)   // testing for first red set
         {
            if (macd4 < 0 && macd44 == 0)  //ox    start of redset1
            { 
               redmarker1 = 1; 
               if (macd4 < rednew) rednew = macd4;
            }
            if (macd4 < 0 && macd44 < 0)    // xx  values within redset1
            {
               if (macd4 <= macd44 && macd4 <= rednew) rednew = macd4;
               else if (macd44 < rednew) rednew = macd44;           
            }    
            if (macd4 == 0 && macd44 < 0)       // xo   end of redset1
            {
               if (macd44 < rednew) rednew = macd44;
            }
         }
            
         else if (redmarker1 == 1)   // testing for second red set
         {
            if (macd4 < 0 && macd44 == 0)  //ox    start of redset2
            { 
               redmarker2 = 1; 
               if (macd4 < redold) redold = macd4;
            }
            if (macd4 < 0 && macd44 < 0)    // xx  values within redset2
            {
               if (macd4 <= macd44 && macd4 <= redold) redold = macd4;
               else if (macd44 < redold) redold = macd44;
            }    
            if (macd4 == 0 && macd44 < 0)       // xo   end of redset2
            {
               if (macd44 < redold) redold = macd44;
            }
         }
         
         if (bluemarker1 == 1 && bluemarker2 == 1 && redmarker1 == 1 && redmarker2 ==1) // = 2 sets each of the most recent blue and red bars have been analyzed
         {         
            double macdblue = iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,2,1); 
            double macdred = iCustom(NULL, 0, "MACD_inColor",TimeFrame,FastEMA,SlowEMA,SignalSMA,applied_price,3,1); 
     
            if (mmacdtrend == 0 || mmacdtrend == -1 && macdblue > 0 && bluenew > blueold)
            {
               mmacdtrend = 1;
            }
            else if (mmacdtrend == 0 || mmacdtrend == 1 && macdred < 0 && rednew < redold)   
            {
               mmacdtrend = -1;
            }
            break;
         }       
      }
   return(mmacdtrend);           
}  


//+------------------------------------------------------------------+
//| OrderReliable Routines - Added NK 20-Feb-09                      |
//+------------------------------------------------------------------+ 


int OrderSendReliable(string symbol, int cmd, double volume, double price,
					  int slippage, double stoploss, double takeprofit,
					  string comment, int magic, datetime expiration = 0, 
					  color arrow_color = CLR_NONE) 
{

	// ------------------------------------------------
	// Check basic conditions see if trade is possible. 
	// ------------------------------------------------
	OrderReliable_Fname = "OrderSendReliable";
	OrderReliablePrint(" attempted " + OrderReliable_CommandString(cmd) + " " + volume + 
						" lots @" + price + " sl:" + stoploss + " tp:" + takeprofit); 
						
	if (!IsConnected()) 
	{
		OrderReliablePrint("error: IsConnected() == false");
		_OR_err = ERR_NO_CONNECTION; 
		return(-1);
	}
	
	if (IsStopped()) 
	{
		OrderReliablePrint("error: IsStopped() == true");
		_OR_err = ERR_COMMON_ERROR; 
		return(-1);
	}
	
	int cnt = 0;
	while(!IsTradeAllowed() && cnt < retry_attempts) 
	{
		OrderReliable_SleepRandomTime(sleep_time, sleep_maximum); 
		cnt++;
	}
	
	if (!IsTradeAllowed()) 
	{
		OrderReliablePrint("error: no operation possible because IsTradeAllowed()==false, even after retries.");
		_OR_err = ERR_TRADE_CONTEXT_BUSY; 

		return(-1);  
	}

	// Normalize all price / stoploss / takeprofit to the proper # of digits.
	int digits = MarketInfo(symbol, MODE_DIGITS);
	if (digits > 0) 
	{
		price = NormalizeDouble(price, digits);
		stoploss = NormalizeDouble(stoploss, digits);
		takeprofit = NormalizeDouble(takeprofit, digits); 
	}
	
	if (stoploss != 0) 
		OrderReliable_EnsureValidStop(symbol, price, stoploss); 

	int err = GetLastError(); // clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	bool exit_loop = false;
	bool limit_to_market = false; 
	
	// limit/stop order. 
	int ticket=-1;

	if ((cmd == OP_BUYSTOP) || (cmd == OP_SELLSTOP) || (cmd == OP_BUYLIMIT) || (cmd == OP_SELLLIMIT)) 
	{
		cnt = 0;
		while (!exit_loop) 
		{
			if (IsTradeAllowed()) 
			{
				ticket = OrderSend(symbol, cmd, volume, price, slippage, stoploss, 
									takeprofit, comment, magic, expiration, arrow_color);
				err = GetLastError();
				_OR_err = err; 
			} 
			else 
			{
				cnt++;
			} 
			
			switch (err) 
			{
				case ERR_NO_ERROR:
					exit_loop = true;
					break;
				
				// retryable errors
				case ERR_SERVER_BUSY:
				case ERR_NO_CONNECTION:
				case ERR_INVALID_PRICE:
				case ERR_OFF_QUOTES:
				case ERR_BROKER_BUSY:
				case ERR_TRADE_CONTEXT_BUSY: 
					cnt++; 
					break;
					
				case ERR_PRICE_CHANGED:
				case ERR_REQUOTE:
					RefreshRates();
					continue;	// we can apparently retry immediately according to MT docs.
					
				case ERR_INVALID_STOPS:
					double servers_min_stop = MarketInfo(symbol, MODE_STOPLEVEL) * MarketInfo(symbol, MODE_POINT); 
					if (cmd == OP_BUYSTOP) 
					{
						// If we are too close to put in a limit/stop order so go to market.
						if (MathAbs(Ask - price) <= servers_min_stop)	
							limit_to_market = true; 
							
					} 
					else if (cmd == OP_SELLSTOP) 
					{
						// If we are too close to put in a limit/stop order so go to market.
						if (MathAbs(Bid - price) <= servers_min_stop)
							limit_to_market = true; 
					}
					exit_loop = true; 
					break; 
					
				default:
					// an apparently serious error.
					exit_loop = true;
					break; 
					
			}  // end switch 

			if (cnt > retry_attempts) 
				exit_loop = true; 
			 	
			if (exit_loop) 
			{
				if (err != ERR_NO_ERROR) 
				{
					OrderReliablePrint("non-retryable error: " + OrderReliableErrTxt(err)); 
				}
				if (cnt > retry_attempts) 
				{
					OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
				}
			}
			 
			if (!exit_loop) 
			{
				OrderReliablePrint("retryable error (" + cnt + "/" + retry_attempts + 
									"): " + OrderReliableErrTxt(err)); 
				OrderReliable_SleepRandomTime(sleep_time, sleep_maximum); 
				RefreshRates(); 
			}
		}
		 
		// We have now exited from loop. 
		if (err == ERR_NO_ERROR) 
		{
			OrderReliablePrint("apparently successful OP_BUYSTOP or OP_SELLSTOP order placed, details follow.");
			OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES); 
			OrderPrint(); 
			return(ticket); // SUCCESS! 
		} 
		if (!limit_to_market) 
		{
			OrderReliablePrint("failed to execute stop or limit order after " + cnt + " retries");
			OrderReliablePrint("failed trade: " + OrderReliable_CommandString(cmd) + " " + symbol + 
								"@" + price + " tp@" + takeprofit + " sl@" + stoploss); 
			OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
			return(-1); 
		}
	}  // end	  
  
	if (limit_to_market) 
	{
		OrderReliablePrint("going from limit order to market order because market is too close.");
		if ((cmd == OP_BUYSTOP) || (cmd == OP_BUYLIMIT)) 
		{
			cmd = OP_BUY;
			price = Ask;
		} 
		else if ((cmd == OP_SELLSTOP) || (cmd == OP_SELLLIMIT)) 
		{
			cmd = OP_SELL;
			price = Bid;
		}	
	}
	
	// we now have a market order.
	err = GetLastError(); // so we clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	ticket = -1;

	if ((cmd == OP_BUY) || (cmd == OP_SELL)) 
	{
		cnt = 0;
		while (!exit_loop) 
		{
			if (IsTradeAllowed()) 
			{
				ticket = OrderSend(symbol, cmd, volume, price, slippage, 
									stoploss, takeprofit, comment, magic, 
									expiration, arrow_color);
				err = GetLastError();
				_OR_err = err; 
			} 
			else 
			{
				cnt++;
			} 
			switch (err) 
			{
				case ERR_NO_ERROR:
					exit_loop = true;
					break;
					
				case ERR_SERVER_BUSY:
				case ERR_NO_CONNECTION:
				case ERR_INVALID_PRICE:
				case ERR_OFF_QUOTES:
				case ERR_BROKER_BUSY:
				case ERR_TRADE_CONTEXT_BUSY: 
					cnt++; // a retryable error
					break;
					
				case ERR_PRICE_CHANGED:
				case ERR_REQUOTE:
					RefreshRates();
					continue; // we can apparently retry immediately according to MT docs.
					
				default:
					// an apparently serious, unretryable error.
					exit_loop = true;
					break; 
					
			}  // end switch 

			if (cnt > retry_attempts) 
			 	exit_loop = true; 
			 	
			if (!exit_loop) 
			{
				OrderReliablePrint("retryable error (" + cnt + "/" + 
									retry_attempts + "): " + OrderReliableErrTxt(err)); 
				OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
				RefreshRates(); 
			}
			
			if (exit_loop) 
			{
				if (err != ERR_NO_ERROR) 
				{
					OrderReliablePrint("non-retryable error: " + OrderReliableErrTxt(err)); 
				}
				if (cnt > retry_attempts) 
				{
					OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
				}
			}
		}
		
		// we have now exited from loop. 
		if (err == ERR_NO_ERROR) 
		{
			OrderReliablePrint("apparently successful OP_BUY or OP_SELL order placed, details follow.");
			OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES); 
			OrderPrint(); 
			return(ticket); // SUCCESS! 
		} 
		OrderReliablePrint("failed to execute OP_BUY/OP_SELL, after " + cnt + " retries");
		OrderReliablePrint("failed trade: " + OrderReliable_CommandString(cmd) + " " + symbol + 
							"@" + price + " tp@" + takeprofit + " sl@" + stoploss); 
		OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
		return(-1); 
	}
}
	
	
//=============================================================================
//							 OrderModifyReliable()
//
//	This is intended to be a drop-in replacement for OrderModify() which, 
//	one hopes, is more resistant to various forms of errors prevalent 
//	with MetaTrader.
//			  
//	RETURN VALUE: 
//
//		TRUE if successful, FALSE otherwise
//
//
//	FEATURES:
//
//		 * Re-trying under some error conditions, sleeping a random 
//		   time defined by an exponential probability distribution.
//
//		 * Displays various error messages on the log for debugging.
//
//
//	Matt Kennel, mbkennel@gmail.com  	2006-05-28
//
//=============================================================================
bool OrderModifyReliable(int ticket, double price, double stoploss, 
						 double takeprofit, datetime expiration, 
						 color arrow_color = CLR_NONE) 
{
	OrderReliable_Fname = "OrderModifyReliable";

	OrderReliablePrint(" attempted modify of #" + ticket + " price:" + price + 
						" sl:" + stoploss + " tp:" + takeprofit); 

	if (!IsConnected()) 
	{
		OrderReliablePrint("error: IsConnected() == false");
		_OR_err = ERR_NO_CONNECTION; 
		return(false);
	}
	
	if (IsStopped()) 
	{
		OrderReliablePrint("error: IsStopped() == true");
		return(false);
	}
	
	int cnt = 0;
	while(!IsTradeAllowed() && cnt < retry_attempts) 
	{
		OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
		cnt++;
	}
	if (!IsTradeAllowed()) 
	{
		OrderReliablePrint("error: no operation possible because IsTradeAllowed()==false, even after retries.");
		_OR_err = ERR_TRADE_CONTEXT_BUSY; 
		return(false);  
	}


	
	if (false) {
		 // This section is 'nulled out', because
		 // it would have to involve an 'OrderSelect()' to obtain
		 // the symbol string, and that would change the global context of the
		 // existing OrderSelect, and hence would not be a drop-in replacement
		 // for OrderModify().
		 //
		 // See OrderModifyReliableSymbol() where the user passes in the Symbol 
		 // manually.
		 
		 OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
		 string symbol = OrderSymbol();
		 int digits = MarketInfo(symbol,MODE_DIGITS);
		 if (digits > 0) {
			 price = NormalizeDouble(price,digits);
			 stoploss = NormalizeDouble(stoploss,digits);
			 takeprofit = NormalizeDouble(takeprofit,digits); 
		 }
		 if (stoploss != 0) OrderReliable_EnsureValidStop(symbol,price,stoploss); 
	}



	int err = GetLastError(); // so we clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	bool exit_loop = false;
	cnt = 0;
	bool result = false;
	
	while (!exit_loop) 
	{
		if (IsTradeAllowed()) 
		{
			result = OrderModify(ticket, price, stoploss, 
								 takeprofit, expiration, arrow_color);
			err = GetLastError();
			_OR_err = err; 
		} 
		else 
			cnt++;

		if (result == true) 
			exit_loop = true;

		switch (err) 
		{
			case ERR_NO_ERROR:
				exit_loop = true;
				break;
				
			case ERR_NO_RESULT:
				// modification without changing a parameter. 
				// if you get this then you may want to change the code.
				exit_loop = true;
				break;
				
			case ERR_SERVER_BUSY:
			case ERR_NO_CONNECTION:
			case ERR_INVALID_PRICE:
			case ERR_OFF_QUOTES:
			case ERR_BROKER_BUSY:
			case ERR_TRADE_CONTEXT_BUSY: 
			case ERR_TRADE_TIMEOUT:		// for modify this is a retryable error, I hope. 
				cnt++; 	// a retryable error
				break;
				
			case ERR_PRICE_CHANGED:
			case ERR_REQUOTE:
				RefreshRates();
				continue; 	// we can apparently retry immediately according to MT docs.
				
			default:
				// an apparently serious, unretryable error.
				exit_loop = true;
				break; 
				
		}  // end switch 

		if (cnt > retry_attempts) 
			exit_loop = true; 
			
		if (!exit_loop) 
		{
			OrderReliablePrint("retryable error (" + cnt + "/" + retry_attempts + 
								"): "  +  OrderReliableErrTxt(err)); 
			OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
			RefreshRates(); 
		}
		
		if (exit_loop) 
		{
			if ((err != ERR_NO_ERROR) && (err != ERR_NO_RESULT)) 
				OrderReliablePrint("non-retryable error: "  + OrderReliableErrTxt(err)); 

			if (cnt > retry_attempts) 
				OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
		}
	}  
	
	// we have now exited from loop. 
	if ((result == true) || (err == ERR_NO_ERROR)) 
	{
		OrderReliablePrint("apparently successful modification order, updated trade details follow.");
		OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES); 
		OrderPrint(); 
		return(true); // SUCCESS! 
	} 
	
	if (err == ERR_NO_RESULT) 
	{
		OrderReliablePrint("Server reported modify order did not actually change parameters.");
		OrderReliablePrint("redundant modification: "  + ticket + " " + symbol + 
							"@" + price + " tp@" + takeprofit + " sl@" + stoploss); 
		OrderReliablePrint("Suggest modifying code logic to avoid."); 
		return(true);
	}
	
	OrderReliablePrint("failed to execute modify after " + cnt + " retries");
	OrderReliablePrint("failed modification: "  + ticket + " " + symbol + 
						"@" + price + " tp@" + takeprofit + " sl@" + stoploss); 
	OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
	
	return(false);  
}
 
 
//=============================================================================
//
//						OrderModifyReliableSymbol()
//
//	This has the same calling sequence as OrderModify() except that the 
//	user must provide the symbol.
//
//	This function will then be able to ensure proper normalization and 
//	stop levels.
//
//=============================================================================
bool OrderModifyReliableSymbol(string symbol, int ticket, double price, 
							   double stoploss, double takeprofit, 
							   datetime expiration, color arrow_color = CLR_NONE) 
{
	int digits = MarketInfo(symbol, MODE_DIGITS);
	
	if (digits > 0) 
	{
		price = NormalizeDouble(price, digits);
		stoploss = NormalizeDouble(stoploss, digits);
		takeprofit = NormalizeDouble(takeprofit, digits); 
	}
	
	if (stoploss != 0) 
		OrderReliable_EnsureValidStop(symbol, price, stoploss); 
		
	return(OrderModifyReliable(ticket, price, stoploss, 
								takeprofit, expiration, arrow_color)); 
	
}
 
 
//=============================================================================
//							 OrderCloseReliable()
//
//	This is intended to be a drop-in replacement for OrderClose() which, 
//	one hopes, is more resistant to various forms of errors prevalent 
//	with MetaTrader.
//			  
//	RETURN VALUE: 
//
//		TRUE if successful, FALSE otherwise
//
//
//	FEATURES:
//
//		 * Re-trying under some error conditions, sleeping a random 
//		   time defined by an exponential probability distribution.
//
//		 * Displays various error messages on the log for debugging.
//
//
//	Derk Wehler, ashwoods155@yahoo.com  	2006-07-19
//
//=============================================================================
bool OrderCloseReliable(int ticket, double lots, double price, 
						int slippage, color arrow_color = CLR_NONE) 
{
	OrderReliable_Fname = "OrderCloseReliable";

	OrderReliablePrint(" attempted close of #" + ticket + " price:" + price + 
						" lots:" + lots + " slippage:" + slippage); 

	if (!IsConnected()) 
	{
		OrderReliablePrint("error: IsConnected() == false");
		_OR_err = ERR_NO_CONNECTION; 
		return(false);
	}
	
	if (IsStopped()) 
	{
		OrderReliablePrint("error: IsStopped() == true");
		return(false);
	}
	
	int cnt = 0;
	while(!IsTradeAllowed() && cnt < retry_attempts) 
	{
		OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
		cnt++;
	}
	if (!IsTradeAllowed()) 
	{
		OrderReliablePrint("error: no operation possible because IsTradeAllowed()==false, even after retries.");
		_OR_err = ERR_TRADE_CONTEXT_BUSY; 
		return(false);  
	}


	int err = GetLastError(); // so we clear the global variable.  
	err = 0; 
	_OR_err = 0; 
	bool exit_loop = false;
	cnt = 0;
	bool result = false;
	
	while (!exit_loop) 
	{
		if (IsTradeAllowed()) 
		{
			result = OrderClose(ticket, lots, price, slippage, arrow_color);
			err = GetLastError();
			_OR_err = err; 
		} 
		else 
			cnt++;

		if (result == true) 
			exit_loop = true;

		switch (err) 
		{
			case ERR_NO_ERROR:
				exit_loop = true;
				break;
				
			case ERR_SERVER_BUSY:
			case ERR_NO_CONNECTION:
			case ERR_INVALID_PRICE:
			case ERR_OFF_QUOTES:
			case ERR_BROKER_BUSY:
			case ERR_TRADE_CONTEXT_BUSY: 
			case ERR_TRADE_TIMEOUT:		// for modify this is a retryable error, I hope. 
				cnt++; 	// a retryable error
				break;
				
			case ERR_PRICE_CHANGED:
			case ERR_REQUOTE:
				RefreshRates();
				continue; 	// we can apparently retry immediately according to MT docs.
				
			default:
				// an apparently serious, unretryable error.
				exit_loop = true;
				break; 
				
		}  // end switch 

		if (cnt > retry_attempts) 
			exit_loop = true; 
			
		if (!exit_loop) 
		{
			OrderReliablePrint("retryable error (" + cnt + "/" + retry_attempts + 
								"): "  +  OrderReliableErrTxt(err)); 
			OrderReliable_SleepRandomTime(sleep_time,sleep_maximum); 
			RefreshRates(); 
		}
		
		if (exit_loop) 
		{
			if ((err != ERR_NO_ERROR) && (err != ERR_NO_RESULT)) 
				OrderReliablePrint("non-retryable error: "  + OrderReliableErrTxt(err)); 

			if (cnt > retry_attempts) 
				OrderReliablePrint("retry attempts maxed at " + retry_attempts); 
		}
	}  
	
	// we have now exited from loop. 
	if ((result == true) || (err == ERR_NO_ERROR)) 
	{
		OrderReliablePrint("apparently successful modification order, updated trade details follow.");
		OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES); 
		OrderPrint(); 
		return(true); // SUCCESS! 
	} 
	
	OrderReliablePrint("failed to execute close after " + cnt + " retries");
	OrderReliablePrint("failed close: Ticket #" + ticket + ", Price: " + 
						price + ", Slippage: " + slippage); 
	OrderReliablePrint("last error: " + OrderReliableErrTxt(err)); 
	
	return(false);  
}
 
 

//=============================================================================
//=============================================================================
//								Utility Functions
//=============================================================================
//=============================================================================



int OrderReliableLastErr() 
{
	return (_OR_err); 
}


string OrderReliableErrTxt(int err) 
{
	return ("" + err + ":" + ErrorDescription(err)); 
}


void OrderReliablePrint(string s) 
{
	// Print to log prepended with stuff;
	Print(OrderReliable_Fname + " " + OrderReliableVersion + ":" + s);
}


string OrderReliable_CommandString(int cmd) 
{
	if (cmd == OP_BUY) 
		return("OP_BUY");

	if (cmd == OP_SELL) 
		return("OP_SELL");

	if (cmd == OP_BUYSTOP) 
		return("OP_BUYSTOP");

	if (cmd == OP_SELLSTOP) 
		return("OP_SELLSTOP");

	if (cmd == OP_BUYLIMIT) 
		return("OP_BUYLIMIT");

	if (cmd == OP_SELLLIMIT) 
		return("OP_SELLLIMIT");

	return("(CMD==" + cmd + ")"); 
}


//=============================================================================
//
//						 OrderReliable_EnsureValidStop()
//
// 	Adjust stop loss so that it is legal.
//
//	Matt Kennel mbkennel@gmail.com.
//
//=============================================================================
void OrderReliable_EnsureValidStop(string symbol, double price, double& sl) 
{
	// Return if no S/L
	if (sl == 0) 
		return;
	
	double servers_min_stop = MarketInfo(symbol, MODE_STOPLEVEL) * MarketInfo(symbol, MODE_POINT); 
	
	if (MathAbs(price - sl) <= servers_min_stop) 
	{
		// we have to adjust the stop.
		if (price > sl)
			sl = price - servers_min_stop;	// we are long
			
		else if (price < sl)
			sl = price + servers_min_stop;	// we are short
			
		else
			OrderReliablePrint("EnsureValidStop: error, passed in price == sl, cannot adjust"); 
			
		sl = NormalizeDouble(sl, MarketInfo(symbol, MODE_DIGITS)); 
	}
}


//=============================================================================
//
//						 OrderReliable_SleepRandomTime()
//
//	This sleeps a random amount of time defined by an exponential 
//	probability distribution. The mean time, in Seconds is given 
//	in 'mean_time'.
//
//	This is the back-off strategy used by Ethernet.  This will 
//	quantize in tenths of seconds, so don't call this with a too 
//	small a number.  This returns immediately if we are backtesting
//	and does not sleep.
//
//	Matt Kennel mbkennel@gmail.com.
//
//=============================================================================
void OrderReliable_SleepRandomTime(double mean_time, double max_time) 
{
	if (IsTesting()) 
		return; 	// return immediately if backtesting.

	double tenths = MathCeil(mean_time / 0.1);
	if (tenths <= 0) 
		return; 
	 
	int maxtenths = MathRound(max_time/0.1); 
	double p = 1.0 - 1.0 / tenths; 
	  
	Sleep(1000); 	// one tenth of a second
	
	for(int i=0; i < maxtenths; i++)  
	{
		if (MathRand() > p*32768) 
			break; 
			
		// MathRand() returns in 0..32767
		Sleep(1000); 
	}
}  



